// dboDiary.H : Declaration of the CdboDiary class

#ifndef __DBODIARY_H_
#define __DBODIARY_H_

class CdboDiaryAccessor
{
public:
	LONG m_ID;
	DBTIMESTAMP m_Date;
	LONG m_Weather;
	TCHAR m_Title[256];
	TCHAR m_Contents[501];

BEGIN_COLUMN_MAP(CdboDiaryAccessor)
	COLUMN_ENTRY(1, m_ID)
	COLUMN_ENTRY(2, m_Date)
	COLUMN_ENTRY(3, m_Weather)
	COLUMN_ENTRY(4, m_Title)
	COLUMN_ENTRY(5, m_Contents)
END_COLUMN_MAP()

DEFINE_COMMAND(CdboDiaryAccessor, _T(" \
	SELECT \
		ID, \
		Date, \
		Weather, \
		Title, \
		Contents  \
		FROM dbo.Diary"))

	// You may wish to call this function if you are inserting a record and wish to
	// initialize all the fields, if you are not going to explicitly set all of them.
	void ClearRecord()
	{
		memset(this, 0, sizeof(*this));
	}
};

class CdboDiary : public CCommand<CAccessor<CdboDiaryAccessor> >
{
public:
	HRESULT Open()
	{
		HRESULT		hr;

		hr = OpenDataSource();
		if (FAILED(hr))
			return hr;

		return OpenRowset();
	}
	HRESULT OpenDataSource()
	{
		HRESULT		hr;
		CDataSource db;
		CDBPropSet	dbinit(DBPROPSET_DBINIT);

		dbinit.AddProperty(DBPROP_AUTH_PASSWORD, OLESTR("*********"));
		dbinit.AddProperty(DBPROP_AUTH_PERSIST_SENSITIVE_AUTHINFO, false);
		dbinit.AddProperty(DBPROP_AUTH_USERID, OLESTR("sa"));
		dbinit.AddProperty(DBPROP_INIT_CATALOG, OLESTR("Diary"));
		dbinit.AddProperty(DBPROP_INIT_DATASOURCE, OLESTR("BRILLIANT"));
		dbinit.AddProperty(DBPROP_INIT_LCID, (long)1042);
		dbinit.AddProperty(DBPROP_INIT_PROMPT, (short)4);
		hr = db.Open(_T("SQLOLEDB.1"), &dbinit);
		if (FAILED(hr))
			return hr;

		return m_session.Open(db);
	}
	HRESULT OpenRowset()
	{
		// Set properties for open
		CDBPropSet	propset(DBPROPSET_ROWSET);
		propset.AddProperty(DBPROP_IRowsetChange, true);
		propset.AddProperty(DBPROP_UPDATABILITY, DBPROPVAL_UP_CHANGE | DBPROPVAL_UP_INSERT | DBPROPVAL_UP_DELETE);

		return CCommand<CAccessor<CdboDiaryAccessor> >::Open(m_session, NULL, &propset);
	}
	CSession	m_session;
};

#endif // __DBODIARY_H_
